package com.mortals.xhx.daemon.applicationservice;

import com.mortals.framework.model.Context;
import com.mortals.framework.service.ICacheService;
import com.mortals.framework.service.IUser;
import com.mortals.framework.springcloud.config.web.BaseWebMvcConfigurer;
import com.mortals.framework.util.ThreadPool;
import com.mortals.xhx.base.system.user.model.UserEntity;
import com.mortals.xhx.base.system.user.model.UserQuery;
import com.mortals.xhx.base.system.user.service.UserService;
import com.mortals.xhx.common.pdu.user.UserPdu;
import com.mortals.xhx.common.utils.BeanUtil;
import com.mortals.xhx.common.utils.SyncTreeSiteThread;
import com.mortals.xhx.feign.user.IUserFeign;
import com.mortals.xhx.module.site.model.SiteTreeSelect;
import com.mortals.xhx.module.site.service.SiteService;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Component;

import com.mortals.framework.springcloud.service.IApplicationStartedService;
import org.springframework.util.ObjectUtils;

import java.util.List;
@Component
@Slf4j
public class DemoStartedService implements IApplicationStartedService {

    private static Log logger = LogFactory.getLog(DemoStartedService.class);
//    @Autowired
//    private IUserFeign userFeign;
    @Autowired
    private UserService userService;

    @Override
    public void start() {
        logger.info("开始服务..[初始化用户站点树]");
        UserEntity userEntity = new UserEntity();
        userEntity.initAttrValue();
        userEntity.setId(0L);
        Context contextTemp = new Context();
        contextTemp.setUser(userEntity);
        SyncTreeSiteThread syncTreeSiteThread = new SyncTreeSiteThread(contextTemp);
        ThreadPool.getInstance().execute(syncTreeSiteThread);

        userEntity = new UserEntity();
        userEntity.initAttrValue();
        userEntity.setId(1L);
         contextTemp = new Context();
        contextTemp.setUser(userEntity);
         syncTreeSiteThread = new SyncTreeSiteThread(contextTemp);
        ThreadPool.getInstance().execute(syncTreeSiteThread);


/*        userService.find(new UserQuery()).forEach(user->{
            Context context = new Context();
            context.setUser(user);
            ThreadPool.getInstance().execute(new SyncTreeSiteThread(context));
        });*/

/*        if(ObjectUtils.isEmpty(userFeign)){
            logger.info("userFeign未加载,加载本地用户");
            userService.find(new UserQuery()).forEach(user->{
                Context context = new Context();
                context.setUser(user);
                ThreadPool.getInstance().execute(new SyncTreeSiteThread(context));
            });

            return;
        }*/

/*        userFeign.list(new UserPdu()).getData().getData().stream().forEach(userPdu->{
            Context context = new Context();

            UserEntity entity = new UserEntity();
            entity.initAttrValue();
            BeanUtils.copyProperties(userPdu, entity, BeanUtil.getNullPropertyNames(userPdu));

            context.setUser(entity);
            ThreadPool.getInstance().execute(new SyncTreeSiteThread(context));
        });*/
    }

    @Override
    public void stop() {
        logger.info("停止服务..");
    }

    @Override
    public int getOrder() {
        return 10;
    }

}
